> ## Documentation Index
> Fetch the complete documentation index at: https://docs.p2p.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Compound Rewards Request

> Create a request to compound accumulated staking rewards by redelegating them to the same validator.



## OpenAPI

````yaml POST /api/v2/monad/{network}/delegators/{delegatorAddress}/stakes/compound-rewards
openapi: 3.0.0
info:
  title: Staking API
  description: API used for staking
  version: 1.0.0
  contact: {}
servers:
  - url: https://api.p2p.org/api
security:
  - bearer: []
tags:
  - name: Aptos
    description: Aptos staking operations (stake, unstake, withdraw, claim).
  - name: Celestia
    description: Celestia staking operations (stake, unstake, redelegate, claim).
  - name: Cosmos
    description: Cosmos Hub staking operations (stake, unstake, redelegate, claim).
  - name: EigenLayer
    description: EigenLayer restaking operations.
  - name: Ethereum
    description: Ethereum staking operations (direct, SSV, pooled).
  - name: Hyperliquid
    description: Hyperliquid staking operations.
  - name: Monad
    description: Monad staking operations (delegate, undelegate, withdraw).
  - name: P2P SSV
    description: P2P-managed SSV validator operations (deposit, claim, withdraw).
  - name: Polkadot
    description: Polkadot staking and nomination pool operations.
  - name: Polygon
    description: Polygon staking operations.
  - name: Pooled Staking
    description: Pooled staking vault operations (deposit, unstake, withdraw).
  - name: Sei
    description: Sei staking operations (stake, unstake, redelegate, claim).
  - name: Solana
    description: Solana staking operations (stake, split, merge, deactivate, withdraw).
  - name: SSV
    description: SSV network validator operations.
  - name: Story
    description: Story network staking operations.
  - name: Sui
    description: Sui staking operations.
  - name: TON
    description: TON staking operations (single nominator, whales pool).
  - name: TRON
    description: TRON staking operations (freeze, delegate, vote, withdraw).
  - name: Unified
    description: Unified multi-chain staking interface.
paths:
  /api/v2/monad/{network}/delegators/{delegatorAddress}/stakes/compound-rewards:
    post:
      tags:
        - Monad
      summary: Create Compound Rewards Request
      description: >-
        Create a request to compound accumulated staking rewards by redelegating
        them to the same validator.
      operationId: monad-delegators-compound-rewards
      parameters:
        - name: network
          required: true
          in: path
          description: >-
            <p>Monad network:</p><ul><li>`mainnet` — Monad
            mainnet.</li><li>`testnet` — Monad testnet.</li></ul>
          schema:
            enum:
              - testnet
              - mainnet
            type: string
        - name: delegatorAddress
          required: true
          in: path
          description: Delegator address on the Monad network.
          schema:
            example: '0x1234567890abcdef1234567890abcdef12345678'
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MonadCreateCompoundRewardsRequest'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/SuccessResponse'
                  - type: object
                    properties:
                      result:
                        $ref: >-
                          #/components/schemas/MonadCreateCompoundRewardsResponse
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - $ref: '#/components/schemas/CommonValidationException'
                          - $ref: '#/components/schemas/MonadInvalidAddressException'
                          - $ref: >-
                              #/components/schemas/MonadDelegatorDoesNotHaveRewardsException
                          - $ref: >-
                              #/components/schemas/MonadDelegatorDoesNotExistException
              examples:
                ValidationException:
                  value:
                    error:
                      code: 100101
                      message: >-
                        The data provided is not valid. Please check the request
                        parameters and try again.
                      name: ValidationException
                      type: client
                    result: null
                MonadInvalidAddressException:
                  value:
                    error:
                      code: 131113
                      message: Invalid Monad address format for address undefined.
                      name: MonadInvalidAddressException
                      type: client
                    result: null
                MonadDelegatorDoesNotHaveRewardsException:
                  value:
                    error:
                      code: 131109
                      message: >-
                        The delegator address does not have any rewards to
                        claim.
                      name: MonadDelegatorDoesNotHaveRewardsException
                      type: client
                    result: null
                MonadDelegatorDoesNotExistException:
                  value:
                    error:
                      code: 131108
                      message: The delegator address does not have any delegations.
                      name: MonadDelegatorDoesNotExistException
                      type: client
                    result: null
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - $ref: '#/components/schemas/AuthNoTokenException'
                          - $ref: '#/components/schemas/AuthWrongTokenException'
              examples:
                NoTokenException:
                  value:
                    error:
                      code: 101111
                      message: >-
                        No Bearer token has been provided. To obtain an
                        authentication token, follow the instructions at
                        https://docs.p2p.org/docs/authentication.
                      name: NoTokenException
                      type: authentication
                    result: null
                WrongTokenException:
                  value:
                    error:
                      code: 101109
                      message: >-
                        An invalid Bearer token has been provided. Please
                        specify the correct authentication token.
                      name: WrongTokenException
                      type: authentication
                    result: null
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ExceptionResponse'
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - $ref: '#/components/schemas/AuthTokenGuardException'
                          - $ref: >-
                              #/components/schemas/MonadCreateCompoundRewardsException
              examples:
                TokenGuardException:
                  value:
                    error:
                      code: 101110
                      message: >-
                        The request could not be performed because the server
                        authorization error occurred.
                      name: TokenGuardException
                      type: server
                    result: null
                MonadCreateCompoundRewardsException:
                  value:
                    error:
                      code: 131103
                      message: Failed to create compound rewards transaction.
                      name: MonadCreateCompoundRewardsException
                      type: server
                    result: null
      security:
        - bearer: []
components:
  schemas:
    MonadCreateCompoundRewardsRequest:
      type: object
      properties:
        gas:
          description: >-
            Computational effort required to execute the transaction measured in
            gas units. If not specified, default gas settings are used.
          allOf:
            - $ref: '#/components/schemas/MonadGasRequest'
    SuccessResponse:
      type: object
      properties:
        error:
          type: object
          nullable: true
          default: null
          description: Error object. Always null on successful responses.
        result:
          type: object
          description: Response payload containing the requested data.
      description: Standard API success response envelope wrapping the result payload.
      required:
        - error
        - result
    MonadCreateCompoundRewardsResponse:
      type: object
      properties:
        createdAt:
          type: string
          description: Timestamp of the transaction in the ISO 8601 format.
          example: '2025-05-06T10:40:00.000Z'
        delegatorAddress:
          type: string
          description: Delegator address.
          example: '0x1234567890abcdef1234567890abcdef12345678'
        gas:
          description: >-
            Computational effort required to execute the transaction measured in
            gas units.
          allOf:
            - $ref: '#/components/schemas/MonadGasResponse'
        unsignedTransaction:
          type: string
          description: >-
            Unsigned transaction in the hexadecimal format. Sign the transaction
            and submit it to the blockchain to perform the called action.
          example: 0x02f8758301e24004...
        validatorId:
          type: integer
          format: int64
          description: >-
            ID of the validator to which the accumulated rewards are delegated
            back.
          example: 1
      required:
        - createdAt
        - delegatorAddress
        - gas
        - unsignedTransaction
        - validatorId
    ExceptionResponse:
      type: object
      properties:
        error:
          type: object
          description: Error object containing exception details. Null on success.
        result:
          type: object
          nullable: true
          default: null
          description: Result payload. Always null on error responses.
        requestId:
          type: string
          description: >-
            Identifier of the request (the `x-request-id` header). Quote this
            value to correlate the response with server logs.
          example: 90c16e9e-6e99-4651-a033-60290356df2f
        timestamp:
          type: string
          format: date-time
          description: ISO 8601 timestamp of when the error response was generated.
          example: '2026-05-20T22:29:03.126Z'
      description: Standard API error response envelope wrapping the exception details.
      required:
        - error
        - result
        - timestamp
    CommonValidationException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 100101
          example: 100101
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            The data provided is not valid. Please check the request parameters
            and try again.
          example: >-
            The data provided is not valid. Please check the request parameters
            and try again.
          description: Human-readable error message describing what went wrong.
        errors:
          description: Validation error details when applicable.
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorResponse'
        name:
          type: string
          default: ValidationException
          example: ValidationException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - errors
        - name
    MonadInvalidAddressException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 131113
          example: 131113
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: Invalid Monad address format for address %s.
          example: Invalid Monad address format for address %s.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: MonadInvalidAddressException
          example: MonadInvalidAddressException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    MonadDelegatorDoesNotHaveRewardsException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 131109
          example: 131109
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: The delegator address does not have any rewards to claim.
          example: The delegator address does not have any rewards to claim.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: MonadDelegatorDoesNotHaveRewardsException
          example: MonadDelegatorDoesNotHaveRewardsException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    MonadDelegatorDoesNotExistException:
      type: object
      properties:
        type:
          type: string
          default: client
          example: client
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 131108
          example: 131108
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: The delegator address does not have any delegations.
          example: The delegator address does not have any delegations.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: MonadDelegatorDoesNotExistException
          example: MonadDelegatorDoesNotExistException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    AuthNoTokenException:
      type: object
      properties:
        type:
          type: string
          default: authentication
          example: authentication
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 101111
          example: 101111
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            No Bearer token has been provided. To obtain an authentication
            token, follow the instructions at
            https://docs.p2p.org/docs/authentication.
          example: >-
            No Bearer token has been provided. To obtain an authentication
            token, follow the instructions at
            https://docs.p2p.org/docs/authentication.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: NoTokenException
          example: NoTokenException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    AuthWrongTokenException:
      type: object
      properties:
        type:
          type: string
          default: authentication
          example: authentication
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 101109
          example: 101109
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            An invalid Bearer token has been provided. Please specify the
            correct authentication token.
          example: >-
            An invalid Bearer token has been provided. Please specify the
            correct authentication token.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: WrongTokenException
          example: WrongTokenException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    AuthTokenGuardException:
      type: object
      properties:
        type:
          type: string
          default: server
          example: server
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 101110
          example: 101110
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: >-
            The request could not be performed because the server authorization
            error occurred.
          example: >-
            The request could not be performed because the server authorization
            error occurred.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: TokenGuardException
          example: TokenGuardException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    MonadCreateCompoundRewardsException:
      type: object
      properties:
        type:
          type: string
          default: server
          example: server
          description: Exception category.
        code:
          type: integer
          format: int32
          default: 131103
          example: 131103
          description: Numeric error code identifying the exception type.
        message:
          type: string
          default: Failed to create compound rewards transaction.
          example: Failed to create compound rewards transaction.
          description: Human-readable error message describing what went wrong.
        name:
          type: string
          default: MonadCreateCompoundRewardsException
          example: MonadCreateCompoundRewardsException
          description: Exception class name for runtime error identification.
      required:
        - type
        - code
        - message
        - name
    MonadGasRequest:
      type: object
      properties:
        priorityPricePerGas:
          type: string
          description: >-
            Price per unit of gas in Wei (1 MON = 10¹⁸ Wei), which is added to
            the EIP-1559 block's base fee. This added fee is used to incentivize
            validators to prioritize this transaction.
          example: '21000'
        maxPricePerGas:
          type: string
          description: >-
            Maximum price per unit of gas this transaction will pay for the
            combined EIP-1559 block's base fee and this transaction's priority
            fee in Wei (1 MON = 10¹⁸ Wei).
          example: '1000000000'
    MonadGasResponse:
      type: object
      properties:
        gasLimit:
          type: string
          description: Maximum gas limit for the transaction.
          example: '260850'
        priorityPricePerGas:
          type: string
          description: >-
            Price per unit of gas in Wei (1 Wei = 10⁻¹⁸ MON), which is added to
            the EIP-1559 block's base fee. This added fee is used to incentivize
            validators to prioritize this transaction.
          example: '1000000000'
        maxPricePerGas:
          type: string
          description: >-
            Maximum price per unit of gas this transaction will pay for the
            combined EIP-1559 block's base fee and this transaction's priority
            fee in Wei (1 Wei = 10⁻¹⁸ MON).
          example: '2000000000'
      required:
        - gasLimit
        - priorityPricePerGas
        - maxPricePerGas
    ValidationErrorResponse:
      type: object
      properties:
        property:
          type: string
          description: Name of the property that failed validation.
        constraints:
          type: object
          additionalProperties:
            type: string
          description: Validation constraint details describing what was expected.
      required:
        - property
        - constraints
  responses:
    TooManyRequests:
      description: >-
        Too Many Requests — the client exceeded its rate limit. The response
        advertises when to retry and the active quota via headers.
      headers:
        Retry-After:
          description: Number of seconds to wait before retrying the request.
          schema:
            type: integer
            example: 60
        RateLimit-Limit:
          description: >-
            The request quota (maximum number of requests) for the most
            restrictive applicable window.
          schema:
            type: integer
            example: 120
        RateLimit-Reset:
          description: >-
            Number of seconds until the rate-limit window resets and requests
            are accepted again.
          schema:
            type: integer
            example: 60
        RateLimit-Policy:
          description: >-
            The active rate-limit policy as `<limit>;w=<window-seconds>`,
            comma-separated when multiple windows apply.
          schema:
            type: string
            example: 120;w=60
      content:
        application/json:
          schema:
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: integer
                  name:
                    type: string
                    example: ThrottlerException
                  message:
                    type: string
                    example: ThrottlerException
                  errors:
                    type: array
                    nullable: true
                    items:
                      type: object
              result:
                type: object
                nullable: true
                example: null
              requestId:
                type: string
                description: >-
                  Identifier of the request (the `x-request-id` header). Quote
                  this value to correlate the response with server logs.
                example: 90c16e9e-6e99-4651-a033-60290356df2f
              timestamp:
                type: string
                format: date-time
                description: ISO 8601 timestamp of when the error response was generated.
                example: '2026-05-20T22:29:03.126Z'
  securitySchemes:
    bearer:
      scheme: bearer
      bearerFormat: JWT
      type: http

````

## Related topics

- [Create Claim Rewards Request](/reference/create-celestia-claim-rewards-transaction.md)
- [Getting Started](/docs/staking-polkadot.md)
